#include <stdio.h>
#include <map>
#include <utility>
#include <string>
#include <iostream>

#define MQ 10000000;
using namespace std;

int make_key(int a, int b){
	return a*1000+b;
}
int get_a(int x){return x/1000;}
int get_b(int x){return x%1000;}
int eval(int a, int op, int b){
	switch(op){
		case 10: return a+b;
		case 11: return a-b;
		case 12: return a*b;
		case 13: return a/b;
	}
	return 0;
}

int main (){
	long long QP = 0;
	long long QL = 0;
	int QV[100000];
	int QD[100000];
	int QO[100000];
	int QS[100000];
	int goal;
	
	map<pair<int,int>,int> res;
	bool keys[15];

	char c;
	while(scanf("%c", &c) == 1){
		for(int i = 0; i < 15; i++)keys[i] = false;
		while(c != ' '){
			if(c >= '0' && c <= '9'){
				keys[c-'0'] = true;
			}else{
				switch(c){
					case '+': keys[10] = true;break;
					case '-': keys[11] = true;break;
					case '*': keys[12] = true;break;
					case '/': keys[13] = true;break;
					case '=': keys[14] = true;break;
					default: break;
				}
			}
			scanf("%c", &c);
		}
		scanf("%d\n", &goal);
		for(int i = 0; i < 15; i++){
			if(keys[i])printf("X");
						else printf("O");
		}
	
		for(int i = 0; i < 15; i++)keys[i] = false;
		
		QP = 0;QL = 1;
		QV[0] = 0;QD[0] = 0;QS[0] =0;QO[0] = 14;
		
		if(goal == 0) printf("0\n");
		else{
			bool finished = false;
			int FV,FD,FO,FS;
			while(QP < QL){
				printf(".");
				if(QS[QP] == 0){
					for(int i = 0; i < 15; i++){
						if(keys[i])printf("X");
						else printf("O");
						if(keys[i] && (i <=9)){
							
							int ND = QD[QP]*10+i;
							if(ND >= 0 && ND <= 999){
								printf(".");
								int FOLD = make_key(QV[QP],QO[QP]);
								int SOLD = make_key(QD[QP],QS[QP]);
								int FNEW = make_key(QV[QP],QO[QP]);
								int SNEW = make_key(ND,QS[QP]);
								
								if(res.find(make_pair(FNEW,SNEW)) == res.end()){
									res[make_pair(FNEW,SNEW)] = res[make_pair(FOLD,SOLD)]+1;
									QV[QL] = QV[QP];
									QD[QL] = ND;
									QO[QL] = QO[QP];
									QS[QL] = QS[QP];
									QL++;
									if(ND == goal){
										finished = true;FV = QV[QP]; FO = QO[QP];FD = ND; FS = QS[QP];
									}
								}
							}
						}else if(keys[i]){
							int ND = QD[QP];
							if(QO[QP] != 14)ND = eval(QV[QP],QO[QP],QD[QP]);
							int NO = i;
							int NV = ND;
							int NS = 1;
							if(ND >= 0 && ND <= 999){
								printf(".");
								int FOLD = make_key(QV[QP],QO[QP]);
								int SOLD = make_key(QD[QP],QS[QP]);
								int FNEW = make_key(NV,NO);
								int SNEW = make_key(ND,NS);
								
								if(res.find(make_pair(FNEW,SNEW)) == res.end()){
									res[make_pair(FNEW,SNEW)] = res[make_pair(FOLD,SOLD)]+1;
									QV[QL] = NV;
									QD[QL] = ND;
									QO[QL] = NO;
									QS[QL] = NS;
									QL++;
									if(ND == goal){
										finished = true;FV = NV; FO = NO;FD = ND; FS = NS;
									}
								}
							}
							
						}
						if(finished)break;
					}
					
					
					
				}else{
					for(int i = 0; i < 15; i++){
						if(keys[i] && i <=9){
							int ND = i;
							if(ND >= 0 && ND <= 999){
								printf(".");
								int FOLD = make_key(QV[QP],QO[QP]);
								int SOLD = make_key(QD[QP],QS[QP]);
								int FNEW = make_key(QV[QP],QO[QP]);
								int SNEW = make_key(ND,QS[QP]);
								
								if(res.find(make_pair(FNEW,SNEW)) == res.end()){
									res[make_pair(FNEW,SNEW)] = res[make_pair(FOLD,SOLD)]+1;
									QV[QL] = QV[QP];
									QD[QL] = ND;
									QO[QL] = QO[QP];
									QS[QL] = QS[QP];
									QL++;
									if(ND == goal){
										finished = true;FV = QV[QP]; FO = QO[QP];FD = ND; FS = QS[QP];
									}
								}
							}
						}else if(keys[i]){
							int ND = QD[QP];
							if(QO[QP] != 14 && i == 14)ND = eval(QV[QP],QO[QP],QD[QP]);
							int NO = i;
							int NV = ND;
							int NS = 1;
							if(ND >= 0 && ND <= 999){
								printf(".");
								int FOLD = make_key(QV[QP],QO[QP]);
								int SOLD = make_key(QD[QP],QS[QP]);
								int FNEW = make_key(NV,NO);
								int SNEW = make_key(ND,NS);
								
								if(res.find(make_pair(FNEW,SNEW)) == res.end()){
									res[make_pair(FNEW,SNEW)] = res[make_pair(FOLD,SOLD)]+1;
									QV[QL] = NV;
									QD[QL] = ND;
									QO[QL] = NO;
									QS[QL] = NS;
									QL++;
									if(ND == goal){
										finished = true;FV = NV; FO = NO;FD = ND; FS = NS;
									}
								}
							}
							
						}
					}
					
				}
				
				if(finished)break;
				QP++;
			}
			if(finished){
				printf("%d\n", res[make_pair(make_key(FV,FO),make_key(FD,FS))]);
			}else{
				printf("impossible\n");
			}
			
		}
	}


	return 0;
}


